package com.torn.puyoru.template;

import static com.torn.puyoru.parts.Puyo.R_LEFT;
import static com.torn.puyoru.parts.Puyo.R_RIGHT;

import com.torn.puyoru.parts.Puyo;
import com.torn.puyoru.parts.Table;


public abstract class Player {

	/* ̎ */
	public static final int OP_NO = 0;
	public static final int OP_DOWN = 1;
	public static final int OP_RIGHT = 2;
	public static final int OP_LEFT = 3;
	public static final int OP_ROTATE_RIGHT = 4;
	public static final int OP_ROTATE_LEFT = 5;
	public static final int OP_START = 9;


	/**
	 * ̎ނǂݎ
	 * @return
	 */
	public abstract int readOperate();

	/**
	 * {
	 * Player̎ł͂Ȃ
	 * @param mytable
	 * @param current
	 * @param type
	 * @return
	 */
	public boolean doOperate(Table mytable, Puyo current, int type) {

		boolean ret = false;

		/* ubN̑ */
		switch(type) {
		/* ړ */
		case OP_DOWN:
			ret = mytable.moveDown(current);
			break;
		/* Eړ */
		case OP_RIGHT:
			ret = mytable.moveRight(current);
			break;
		/* ړ */
		case OP_LEFT:
			ret = mytable.moveLeft(current);
			break;
		/* E] */
		case OP_ROTATE_RIGHT:
			ret = mytable.rotate(current, R_RIGHT);
			break;
		/* ] */
		case OP_ROTATE_LEFT:
			ret = mytable.rotate(current, R_LEFT);
			break;
		/* Ȃ */
		case OP_NO:
			ret = true; /* Al͋CɂĂȂ */
			break;
		case OP_START:
			ret = true; /* Al͋CɂĂȂ */
			break;
		/* ͎s */
		default:
			ret = false; /* Al͋CɂĂȂ */
			break;
		}

		return ret;
	}

	/**
	 * Q[Jn}҂
	 * @return
	 */
	public abstract boolean waitStartSign();

}